diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_restart.c ircd-hybrid-6.0/src/m_restart.c
--- ircd-hybrid-6.0.orig/src/m_restart.c	Fri Jun 15 22:41:01 2001
+++ ircd-hybrid-6.0/src/m_restart.c	Fri Jun 15 21:55:22 2001
@@ -108,8 +108,8 @@
       return 0;
     }
 
-  log(L_WARN, "Server RESTART by %s\n", get_client_name(sptr, SHOW_IP));
-  ircsprintf(buf, "Server RESTART by %s", get_client_name(sptr, SHOW_IP));
+  log(L_WARN, "Server RESTART by %s\n", get_client_name(sptr, HIDE_IP));
+  ircsprintf(buf, "Server RESTART by %s", get_client_name(sptr, HIDE_IP));
   restart(buf);
   return 0; /*NOT REACHED*/
 }
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_server.c ircd-hybrid-6.0/src/m_server.c
--- ircd-hybrid-6.0.orig/src/m_server.c	Fri Jun 15 22:41:01 2001
+++ ircd-hybrid-6.0/src/m_server.c	Fri Jun 15 21:54:38 2001
@@ -164,8 +164,8 @@
       if (IsServer(cptr))
         {
           sendto_realops("SERVER command from remote user %s -- %s is a hacked server",
-                          get_client_name(sptr,SHOW_IP),
-                          get_client_name(cptr,SHOW_IP));
+                          get_client_name(sptr,HIDE_IP),
+                          get_client_name(cptr,HIDE_IP));
         }
       else
         {
@@ -228,7 +228,7 @@
         {
 #ifdef WARN_NO_NLINE
           sendto_realops("Link %s Server %s dropped, no N: line",
-                         get_client_name(cptr, TRUE), host);
+                         get_client_name(cptr, FALSE), host);
 #endif
           return exit_client(cptr, cptr, cptr, "NO N line");
         }
@@ -237,7 +237,7 @@
   if (MyConnect(cptr) && (GlobalSetOptions.autoconn == 0))
     {
       sendto_realops("WARNING AUTOCONN is 0, Closing %s",
-                 get_client_name(cptr, TRUE));
+                 get_client_name(cptr, FALSE));
       return exit_client(cptr, cptr, cptr, "AUTOCONNS off");
     }
 
@@ -258,7 +258,7 @@
       if (bcptr == cptr)
       {
         sendto_realops("Link %s cancelled, server %s already exists",
-                   get_client_name(bcptr, TRUE), host);
+                   get_client_name(bcptr, FALSE), host);
         return exit_client(bcptr, bcptr, &me, "Server Exists");
       }
       /*
@@ -271,9 +271,9 @@
        * 2 times in same sendto_ops(), so we have to strcpy one =(
        *  - comstud
        */
-      strcpy(nbuf, get_client_name(bcptr, TRUE));
+      strcpy(nbuf, get_client_name(bcptr, FALSE));
       sendto_realops("Link %s cancelled, server %s reintroduced by %s",
-                nbuf, host, get_client_name(cptr, TRUE));
+                nbuf, host, get_client_name(cptr, FALSE));
       exit_client(bcptr, bcptr, &me, "Server Exists");
     }
 
@@ -320,7 +320,7 @@
           (!aconf->port || (hop > aconf->port)))
         {
           sendto_realops("Leaf-only link %s->%s - Closing",
-                     get_client_name(cptr,  TRUE),
+                     get_client_name(cptr,  FALSE),
                      aconf->host ? aconf->host : "*");
           sendto_one(cptr, "ERROR :Leaf-only link, sorry.");
           return exit_client(cptr, cptr, cptr, "Leaf Only");
@@ -330,10 +330,10 @@
           (aconf->port && (hop > aconf->port)) )
         {
           sendto_realops("Non-Hub link %s introduced %s(%s).",
-                     get_client_name(cptr,  TRUE), host,
+                     get_client_name(cptr,  FALSE), host,
                      aconf ? (aconf->host ? aconf->host : "*") : "!");
           sendto_one(cptr, "ERROR :%s has no H: line for %s.",
-                     get_client_name(cptr,  TRUE), host);
+                     get_client_name(cptr,  FALSE), host);
           return exit_client(cptr, cptr, cptr, "Too many servers");
         }
 
@@ -365,7 +365,7 @@
           if (!(aconf = bcptr->serv->nline))
             {
               sendto_realops("Lost N-line for %s on %s. Closing",
-                         get_client_name(cptr, TRUE), host);
+                         get_client_name(cptr, FALSE), host);
               return exit_client(cptr, cptr, cptr, "Lost N line");
             }
           if (match(my_name_for_link(me.name, aconf), acptr->name))
@@ -395,7 +395,7 @@
   if (!DoesTS(cptr))
     {
       sendto_realops("Link %s dropped, non-TS server",
-                 get_client_name(cptr, TRUE));
+                 get_client_name(cptr, FALSE));
       return exit_client(cptr, cptr, cptr, "Non-TS server");
     }
 
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_svinfo.c ircd-hybrid-6.0/src/m_svinfo.c
--- ircd-hybrid-6.0.orig/src/m_svinfo.c	Tue Oct 17 07:20:50 2000
+++ ircd-hybrid-6.0/src/m_svinfo.c	Fri Jun 15 21:45:04 2001
@@ -118,7 +118,7 @@
        * we drop the link  -orabidoo
        */
       sendto_realops("Link %s dropped, wrong TS protocol version (%s,%s)",
-                 get_client_name(sptr, TRUE), parv[1], parv[2]);
+                 get_client_name(sptr, FALSE), parv[1], parv[2]);
       return exit_client(sptr, sptr, sptr, "Incompatible TS version");
     }
 
@@ -133,7 +133,7 @@
     {
       sendto_realops(
        "Link %s dropped, excessive TS delta (my TS=%d, their TS=%d, delta=%d)",
-                 get_client_name(sptr, TRUE), CurrentTime, theirtime,deltat);
+                 get_client_name(sptr, FALSE), CurrentTime, theirtime,deltat);
       return exit_client(sptr, sptr, sptr, "Excessive TS delta");
     }
 
@@ -141,7 +141,7 @@
     { 
       sendto_realops(
                  "Link %s notable TS delta (my TS=%d, their TS=%d, delta=%d)",
-                 get_client_name(sptr, TRUE), CurrentTime, theirtime, deltat);
+                 get_client_name(sptr, FALSE), CurrentTime, theirtime, deltat);
     }
 
   return 0;
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/s_auth.c ircd-hybrid-6.0/src/s_auth.c
--- ircd-hybrid-6.0.orig/src/s_auth.c	Fri Jun 15 22:40:57 2001
+++ ircd-hybrid-6.0/src/s_auth.c	Fri Jun 15 21:47:47 2001
@@ -251,15 +251,15 @@
 
   if ((fd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
     report_error("creating auth stream socket %s:%s", 
-                 get_client_name(auth->client, TRUE), errno);
+                 get_client_name(auth->client, FALSE), errno);
     log(L_ERROR, "Unable to create auth socket for %s:%m",
-        get_client_name(auth->client, SHOW_IP));
+        get_client_name(auth->client, HIDE_IP));
     ++ServerStats->is_abad;
     return 0;
   }
   if ((MAXCONNECTIONS - 10) < fd) {
     sendto_realops("Can't allocate fd for auth on %s",
-                get_client_name(auth->client, TRUE));
+                get_client_name(auth->client, FALSE));
 
     close(fd);
     return 0;
@@ -267,7 +267,7 @@
 
   sendheader(auth->client, REPORT_DO_ID);
   if (!set_non_blocking(fd)) {
-    report_error(NONB_ERROR_MSG, get_client_name(auth->client, SHOW_IP), errno);
+    report_error(NONB_ERROR_MSG, get_client_name(auth->client, HIDE_IP), errno);
     close(fd);
     return 0;
   }
@@ -285,7 +285,7 @@
 
   if (bind(fd, (struct sockaddr*) &localaddr, sizeof(localaddr))) {
     report_error("binding auth stream socket %s:%s", 
-                 get_client_name(auth->client, TRUE), errno);
+                 get_client_name(auth->client, FALSE), errno);
     close(fd);
     return 0;
   }
@@ -431,7 +431,7 @@
         sendheader(auth->client, REPORT_FAIL_DNS);
       }
       log(L_INFO, "DNS/AUTH timeout %s",
-          get_client_name(auth->client, SHOW_IP));
+          get_client_name(auth->client, HIDE_IP));
 
       auth->client->since = now;
       release_auth_client(auth->client);
@@ -444,7 +444,7 @@
     if (auth->timeout < CurrentTime) {
       delete_resolver_queries(auth);
       sendheader(auth->client, REPORT_FAIL_DNS);
-      log(L_INFO, "DNS timeout %s", get_client_name(auth->client, SHOW_IP));
+      log(L_INFO, "DNS timeout %s", get_client_name(auth->client, HIDE_IP));
 
       auth->client->since = now;
       release_auth_client(auth->client);
@@ -473,7 +473,7 @@
       getpeername(auth->client->fd, (struct sockaddr *)&them, &tlen)) {
 
     log(L_INFO, "auth get{sock,peer}name error for %s:%m",
-        get_client_name(auth->client, SHOW_IP));
+        get_client_name(auth->client, HIDE_IP));
     auth_error(auth);
     return;
   }
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/s_bsd.c ircd-hybrid-6.0/src/s_bsd.c
--- ircd-hybrid-6.0.orig/src/s_bsd.c	Fri Jun 15 22:41:01 2001
+++ ircd-hybrid-6.0/src/s_bsd.c	Fri Jun 15 21:42:50 2001
@@ -459,17 +459,17 @@
               HOSTIPLEN);
 
   if (!set_non_blocking(cptr->fd))
-    report_error(NONB_ERROR_MSG, get_client_name(cptr, TRUE), errno);
+    report_error(NONB_ERROR_MSG, get_client_name(cptr, FALSE), errno);
 
   if (!set_sock_buffers(cptr->fd, READBUF_SIZE))
-    report_error(SETBUF_ERROR_MSG, get_client_name(cptr, TRUE), errno);
+    report_error(SETBUF_ERROR_MSG, get_client_name(cptr, FALSE), errno);
 
   if (connect(cptr->fd, (struct sockaddr*) &sin, sizeof(sin)) && 
       errno != EINPROGRESS)
     {
       int errtmp = errno; /* other system calls may eat errno */
       report_error("Connect to host %s failed: %s",
-                   get_client_name(cptr, TRUE), errno);
+                   get_client_name(cptr, FALSE), errno);
       errno = errtmp;
       return 0;
     }
@@ -508,11 +508,11 @@
   if ((cptr = find_server(aconf->name)))
     {
       sendto_realops("Server %s already present from %s",
-                 aconf->name, get_client_name(cptr, TRUE));
+                 aconf->name, get_client_name(cptr, FALSE));
       if (by && IsPerson(by) && !MyClient(by))
         sendto_one(by, ":%s NOTICE %s :Server %s already present from %s",
                    me.name, by->name, aconf->name,
-                   get_client_name(cptr, TRUE));
+                   get_client_name(cptr, FALSE));
       return 0;
     }
 
@@ -772,9 +772,9 @@
   ++listener->ref_count;
 
   if (!set_non_blocking(new_client->fd))
-    report_error(NONB_ERROR_MSG, get_client_name(new_client, TRUE), errno);
+    report_error(NONB_ERROR_MSG, get_client_name(new_client, FALSE), errno);
   if (!disable_sock_options(new_client->fd))
-    report_error(OPT_ERROR_MSG, get_client_name(new_client, TRUE), errno);
+    report_error(OPT_ERROR_MSG, get_client_name(new_client, FALSE), errno);
   start_auth(new_client);
 }
 
@@ -926,7 +926,7 @@
                    get_client_name(cptr, MASK_IP));
       else
         report_error("Lost connection to %s:%s", 
-                     get_client_name(cptr, TRUE), current_error);
+                     get_client_name(cptr, MASK_IP), current_error);
       sendto_realops("%s had been connected for %d day%s, %2d:%02d:%02d",
                  cptr->name, connected/86400,
                  (connected/86400 == 1) ? "" : "s",
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/s_serv.c ircd-hybrid-6.0/src/s_serv.c
--- ircd-hybrid-6.0.orig/src/s_serv.c	Fri Jun 15 22:41:01 2001
+++ ircd-hybrid-6.0/src/s_serv.c	Fri Jun 15 21:52:52 2001
@@ -547,7 +547,7 @@
     {
       ServerStats->is_ref++;
       sendto_one(cptr,
-                 "ERROR :Access denied. No N line for server %s", inpath_ip);
+                 "ERROR :Access denied. No N line for server %s", inpath);
       sendto_ops("Access denied. No N line for server %s", inpath);
       log(L_NOTICE, "Access denied. No N line for server %s", inpath_ip);
       return exit_client(cptr, cptr, cptr, "No N line for server");
@@ -649,7 +649,7 @@
           ServerStats->is_ref++;
           sendto_realops("Username mismatch [%s]v[%s] : %s",
                      n_conf->user, cptr->username,
-                     get_client_name(cptr, TRUE));
+                     get_client_name(cptr, FALSE));
           sendto_one(cptr, "ERROR :No Username Match");
           return exit_client(cptr, cptr, cptr, "Bad User");
         }
@@ -663,7 +663,7 @@
         {
           zip_free(cptr);
           sendto_realops("Unable to setup compressed link for %s",
-                      get_client_name(cptr, TRUE));
+                      get_client_name(cptr, FALSE));
           return exit_client(cptr, cptr, &me, "zip_init() failed");
         }
       cptr->flags2 |= (FLAGS2_ZIP|FLAGS2_ZIPFIRST);
@@ -699,7 +699,7 @@
    * XXX - this should be in s_bsd
    */
   if (!set_sock_buffers(cptr->fd, READBUF_SIZE))
-    report_error(SETBUF_ERROR_MSG, get_client_name(cptr, TRUE), errno);
+    report_error(SETBUF_ERROR_MSG, get_client_name(cptr, FALSE), errno);
 
   /* LINKLIST */
   /* add to server link list -Dianora */
@@ -864,7 +864,7 @@
   */
   if ((cptr->flags2 & FLAGS2_ZIP) && cptr->zip->out->total_in)
     sendto_realops("Connect burst to %s: %lu, compressed: %lu (%3.1f%%)",
-                get_client_name(cptr, TRUE),
+                get_client_name(cptr, FALSE),
                 cptr->zip->out->total_in,cptr->zip->out->total_out,
                 (100.0*(float)cptr->zip->out->total_out) /
                 (float)cptr->zip->out->total_in);